main(InitialData) :-
        send_result(InitialData),

        read_command(FirstCommand),
        ( fromto(FirstCommand,Command,NextCommand,stop), param(InitialData) do

            ( Command==double ->
                compute(InitialData, 2, Result)
            ; Command==triple ->
                compute(InitialData, 3, Result)
            ; Command==quadruple ->
                compute(InitialData, 4, Result)
            ),
            send_result(Result),
            read_command(NextCommand)
        ),
        send_result(stopped).


read_command(Command) :-
        read_exdr(command_from_tcl, Command).

send_result(Result) :-
        write_exdr(result_from_ecl, Result),
        flush(result_from_ecl).

compute(Xs, N, Ys) :-
        ( foreach(X,Xs), foreach(Y,Ys), param(N) do
            Y is N*X
        ).

